\ 2017-07-09 7seg_1.fs
\
\ Written in 2017 by Erich Wälde <erich.waelde@forth-ev.de>
\
\ To the extent possible under law, the author(s) have dedicated
\ all copyright and related and neighboring rights to this software
\ to the public domain worldwide. This software is distributed
\ without any warranty.
\
\ You should have received a copy of the CC0 Public Domain
\ Dedication along with this software. If not, see
\ <http://creativecommons.org/publicdomain/zero/1.0/>.
\
\ need ewlib/shiftregister.fs
\
\ words
\     _A _B _C ... _G _DP               \ segment names, CUSTOMIZE!
\     7SegDigits                        \ table in flash
\     type.7seg ( xn .. x1 n -- )
\     emit.7sec ( n -- )
\     
\ Pinout Kingbright 7seg displays
\ 
\     top, display side 10 .. 6
\     :  10...6
\     : +---a---+
\     : |       |
\     : f       b
\     : |       |
\     : +---g---+
\     : |       |
\     : e       c
\     : |       |
\     : +---d---+  DP
\     :   1...5
\     bottom, display side 1 .. 5
\ 
\     - 1 :: e
\     - 2 :: d
\     - 3 :: +
\     - 4 :: c
\     - 5 :: DP
\     - 6 :: b
\     - 7 :: a
\     - 8 :: +
\     - 9 :: f
\     - 10 :: g

\ connected bit of each segment
$01 constant _DP
$02 constant _C
$04 constant _D
$08 constant _E
$10 constant _G
$20 constant _F
$40 constant _A
$80 constant _B

\ byte code of each digit
create 7SegDigits
0 _A or _B or _C or _D or _E or _F or       , \ 0
0       _B or _C or                         , \ 1
0 _A or _B or       _D or _E or       _G or , \ 2
0 _A or _B or _C or _D or             _G or , \ 3
0       _B or _C or             _F or _G or , \ 4
0 _A or       _C or _D or       _F or _G or , \ 5
0 _A or       _C or _D or _E or _F or _G or , \ 6
0 _A or _B or _C or                         , \ 7
0 _A or _B or _C or _D or _E or _F or _G or , \ 8
0 _A or _B or _C or _D or       _F or _G or , \ 9
0 _A or _B or _C or       _E or _F or _G or , \ A
0             _C or _D or _E or _F or _G or , \ b
0                   _D or _E or       _G or , \ c
0       _B or _C or _D or _E or       _G or , \ d
0 _A or             _D or _E or _F or _G or , \ E
0 _A or                   _E or _F or _G or , \ F

\ transfer n digits, consult lookup table
: type.7seg ( xn .. x1 n -- )
  0 ?do
    dup 0 #10 within if
    else
      drop 0 \ replace invalid by zero --- questionable!
    then
    7SegDigits + @i  byte>sr
  loop
  sr_latch low sr_latch high
;

\ transfer 1 digit
: emit.7sec ( n -- )
  1 type.7seg
;
