\ 2017-07-14 ewlib/clocks_v0.3.fs
\
\ Written in 2017 by Erich Wälde <erich.waelde@forth-ev.de>
\
\ To the extent possible under law, the author(s) have dedicated
\ all copyright and related and neighboring rights to this software
\ to the public domain worldwide. This software is distributed
\ without any warranty.
\
\ You should have received a copy of the CC0 Public Domain
\ Dedication along with this software. If not, see
\ <http://creativecommons.org/publicdomain/zero/1.0/>.
\
\
\ create an infrastructure to accomodate more than one
\ set of counters for a clock.
\
\ this attempts to spend RAM space and trade it for
\ simpler code. Try to avoid converting times ...
\
\ RAM array of counters (cells)
\ optional: uptime or epochseconds (double)
\ optional: EsecOffset (double)
\ 0: tick (optional)!
\ 1: second
\ 2: minute
\ 3: hour
\ 4: day (offset by 1)
\ 5: month (offset by 1)
\ 6: year
\ 7: pointer to TZ string (flash)

\ include lib/forth2012/facility/structures.frt
#include structures.frt
\ include lib/forth2012/core/buffer.frt

begin-structure _clock_t
  field: __tick
  field: __sec
  field: __min
  field: __hour
  field: __day
  field: __month
  field: __year
  field: __tz
end-structure

\ variable _clock
#36 user _clock
: tick  ( -- addr ) _clock @ __tick  ;
: sec   ( -- addr ) _clock @ __sec   ;
: min   ( -- addr ) _clock @ __min   ;
: hour  ( -- addr ) _clock @ __hour  ;
: day   ( -- addr ) _clock @ __day   ;
: month ( -- addr ) _clock @ __month ;
: year  ( -- addr ) _clock @ __year  ;
: tz    ( -- addr ) _clock @ __tz    ; 


: .date  ( -- )
  year  @    #4 u0.r  \ [char] - emit
  month @ 1+ #2 u0.r  \ [char] - emit
  day   @ 1+ #2 u0.r
;
: .time  ( -- )
  hour  @    #2 u0.r [char] : emit
  min   @    #2 u0.r [char] : emit
  sec   @    #2 u0.r
;
: .tz ( -- )
  tz    @    icount itype 
;


\ define a clock data array including
\ a printing label for its time_zone.
: clock: ( s" tz_label" <clock_name> -- )
  dp >r s, r>                   \ -- flash-p
  create 
  here dup   ( ram-p )   ,      \ -- flash-p ram-p
  over       ( flash-p ) ,
  _clock_t allot                \ -- flash-p ram-p
  _clock !
  tz !
does>
  dup @i _clock !
  1+  @i     tz !
;

\ s" UTC" clock:  master_clock

