\ 2017-05-20 ew
\
\ access to DS3231 RTC --- this is by no means complete!
\
\ Written in 2017 by Erich Wälde <erich.waelde@forth-ev.de>
\
\ To the extent possible under law, the author(s) have dedicated
\ all copyright and related and neighboring rights to this software
\ to the public domain worldwide. This software is distributed
\ without any warranty.
\
\ You should have received a copy of the CC0 Public Domain
\ Dedication along with this software. If not, see
\ <http://creativecommons.org/publicdomain/zero/1.0/>.
\
\ needs:
\     #2000 constant Century
\ 
\ words:
\     rtc.get ( -- sec min hour wday day month year )
\     rtc.dot ( sec min hour wday day month year -- )
\     rtc.show ( --)
\     rtc.set ( year month day wday hour min sec -- )
\     rtc.t.show ( -- )


: rtc.get ( -- sec min hour wday day month year )
  #7 0 1 i2c_addr_rtc  i2c.m!n@
  bcd>dec Century + >r
  bcd>dec >r
  bcd>dec >r
  >r
  bcd>dec >r
  bcd>dec >r
  bcd>dec
  r> r>  r>  r> r> r>
;
: rtc.dot ( sec min hour wday day month year -- )
  #4 u0.r [char] - emit \ year
  #2 u0.r [char] - emit \ month / 7bit century rollover!
  #2 u0.r [char] _ emit \ day-of-month
  >r
  #2 u0.r [char] : emit \ hour / flags?
  #2 u0.r [char] : emit \ minute 
  #2 u0.r               \ second
  r> space .            \ day-of-week
;
: rtc.show ( -- )  rtc.get rtc.dot ;

: rtc.set ( year month day wday hour min sec -- )
  dec>bcd >r            \ second
  dec>bcd >r            \ minute
  dec>bcd >r            \ hour (24h format)
  $07 and >r            \ wday: 1:So 2:Mo .. 7:Sa
  dec>bcd >r            \ day
  dec>bcd >r            \ month; century flag ignored
  #100 mod dec>bcd      \ year % 100
  r> r> r>  r> r> r>
  0 #8 i2c_addr_rtc i2c.n!
;

: rtc.t.show ( -- )
  2 $11 1 i2c_addr_rtc i2c.m!n@
  swap >< +  #6 rshift ( T/[0.25 C] )
  #4 /mod #3 .r [char] . emit 25 * .
;

