\ 2015-11-14 ramtable_to_flash.fs
\
\ Written in 2017 by Erich Wälde <erich.waelde@forth-ev.de>
\
\ To the extent possible under law, the author(s) have dedicated
\ all copyright and related and neighboring rights to this software
\ to the public domain worldwide. This software is distributed
\ without any warranty.
\
\ You should have received a copy of the CC0 Public Domain
\ Dedication along with this software. If not, see
\ <http://creativecommons.org/publicdomain/zero/1.0/>.
\
\ functions to
\     prepare a table in RAM
\     populate table with XTs
\     dump table content
\     copy table to flash
\
\ words
\     ramtable.init ( xt addr length -- )
\     ramtable.dump ( addr length -- )
\     >ramtable ( xt idx addr -- )
\     >flashtable ( srcaddr length -- )  \ ccc.name
\ 
: ramtable.init ( xt addr length -- )
  0 ?do
    over over i cells + !
  loop
  drop drop
;
: ramtable.dump ( addr length -- )
  ." dump " dup . ." cells at " over . cr
  0 ?do
    dup i cells + @ .
  loop
  drop cr
;
: >ramtable ( xt idx addr -- )
  swap cells +  !
;

: >flashtable ( srcaddr length -- )  \ ccc.name
  create ( ccc.name )
  ( length ) 0 ?do
    dup i cells + @ ,
  loop
  drop
  does>
;

: flashtable.dump ( addr length -- )
  ." dump " dup . ." cells at " over . cr
  0 ?do
    dup i + @i .
  loop
  drop
  cr
;