\ 2017-05-10 shiftregister.fs
\
\ Written in 2017 by Erich Wälde <erich.waelde@forth-ev.de>
\
\ To the extent possible under law, the author(s) have dedicated
\ all copyright and related and neighboring rights to this software
\ to the public domain worldwide. This software is distributed
\ without any warranty.
\
\ You should have received a copy of the CC0 Public Domain
\ Dedication along with this software. If not, see
\ <http://creativecommons.org/publicdomain/zero/1.0/>.
\
\
\ needs pin definitions
\     PORTD 2 portpin: sr_latch
\     PORTD 3 portpin: sr_clock
\     PORTD 4 portpin: sr_data
\ words:
\     +sr ( -- )     \ enable shift register
\     emit.sr ( n -- )     \ transfer 1 Byte
\     type.sr ( xn-1 .. x0 n -- )  \ n Bytes

: +sr  
  sr_latch pin_output  sr_latch high
  sr_clock pin_output  sr_clock low
  sr_data  pin_output  sr_data  high
;

: bit>sr ( bit -- )
  if sr_data high else sr_data low then
  sr_clock high  sr_clock low
;

: get.bit ( byte pos -- bit )
  1 swap lshift    \ -- byte bitmask
  and              \ -- bit
;

\ clock one byte out, MSB first!
\ : byte>sr ( byte -- )
\   8 0 do
\     dup 7 i -  \ 7 6 5 ... 0: MSB first!
\     get.bit
\     bit>sr
\   loop
\   drop
\ ;
: byte>sr ( byte -- )
  0 7 do
    dup i get.bit
    bit>sr
  -1 +loop
  drop
;

\ : >sr
\   byte>sr
\   sr_latch low sr_latch high
\ ;

