\ 2015-10-11 ewlib/timeup_v0.0.fs
\
\ Written in 2015 by Erich Wälde <erich.waelde@forth-ev.de>
\
\ To the extent possible under law, the author(s) have dedicated
\ all copyright and related and neighboring rights to this software
\ to the public domain worldwide. This software is distributed
\ without any warranty.
\
\ You should have received a copy of the CC0 Public Domain
\ Dedication along with this software. If not, see
\ <http://creativecommons.org/publicdomain/zero/1.0/>.
\
\
\ variables
\     tu.counts -- fields available as:
\     tick sec min hour day month year
\ words:
\     timeup.init
\     timeup
\     lastday_of_month ( year month -- last_day )
\     tu.get  ( -- S M H d m Y )
\     tu.set  ( Y m d H M S -- )
\     tu.show ( -- )

#include leap_year_q.fs
    
variable tu.flags

variable tu.counts     #7 cells allot
tu.counts            constant tick
tu.counts #1 cells + constant sec
tu.counts #2 cells + constant min
tu.counts #3 cells + constant hour
tu.counts #4 cells + constant day
tu.counts #5 cells + constant month
tu.counts #6 cells + constant year

variable tu.limits     #6       allot

create tu.lastday_of_month
   #31 , #28 , #31 , #30 , #31 , #30 ,
   #31 , #31 , #30 , #31 , #30 , #31 ,

: lastday_of_month ( year month -- last_day )
  dup 1-                \ array starts at 0
  tu.lastday_of_month + @i
  swap #2 = if          \ if month == 2
    swap leap_year? if  \   if leap_year
      1+                \     month += 1
    then
  else                  \ else
    swap drop           \   remove year
  then
;

: timeup.init
  0      tu.flags !
  tu.counts #8 erase
  #60    tu.limits 1 + c!
  #60    tu.limits 2 + c!
  #24    tu.limits 3 + c!
  #31    tu.limits 4 + c! \ fixme: may be wrong later!
  #12    tu.limits 5 + c!
;

: timeup ( -- )
  $02 tu.flags fset                \ secflag++
  1 sec +!                         \ sec++
  
  \ for ( sec ) min hour day month year
  #6 1 do
    i cells tu.counts + @   1+     \ Counts[i]+1
    i       tu.limits + c@         \ Limits[i]
    > if                           \ if C[i]+1 > L[i]
      0  i cells tu.counts +  !    \ . C[i]=0
      i 1+ bv tu.flags fset        \ . F[i+1]++
      1 i 1+ cells tu.counts + +!  \ . C[i+1]++
    then                           \ fi
  loop
;

\ update lastday_of_month in tu.limits
\ once current date is known
: tu.upd.limits ( Y m -- )
  ( Y m ) lastday_of_month  tu.limits #4 + c!
;
